import sys
sys.path.insert(1, '../secure_code')
sys.path.insert(1, '../')
from sign import prvkey_gen, pubkey_gen, sign, verify
import numpy as np

def generateAll():
    sk = prvkey_gen()
    pk = pubkey_gen(sk)

    message = b'fcsc2022'
    sigs = []
    for _ in range(300_000):
        r, s = sign(sk, message)
        sigs.append(np.array([r, s], dtype = object))

    f, g, F, G = sk
    np.save("../secret_data/key.npy", [f, g, F, G])
    np.save("pubkey.npy", pk)
    np.save("sigs.npy", sigs)

def verifyAll():
    pk = np.load("pubkey.npy")
    sigs = np.load("sigs.npy", allow_pickle = True)

    for sig in sigs:
        verify(pk, b'fcsc2022', sig)

if __name__ == "__main__":
    generateAll()
    verifyAll()
