import os
import sys
import numpy as np
import ast
sys.path.insert(1, './secure_code')
from sign import sign, verify

if __name__ == "__main__":
    pk = np.load("./data/pubkey.npy")
    message = 'spaceship_' + os.urandom(8).hex()

    print("Can you sign the name of this ship for us?")
    print(message)
    message = message.encode()

    try:
        print(f"Enter the signature:")
        r = bytes.fromhex(input("r = "))
        s = ast.literal_eval(input("s = "))
        signature = r, s

        if verify(pk, message, signature):
            flag = open("./secret_data/flag.txt").read().strip()
            print("We successfully authorized the ship, thank you! We found a flag for you:")
            print(flag)
        else:
            print("Sorry, the signature has been refused.")
    except:
        print("Please check your inputs.")
